/********************************************************************
 * The Data Acquisition Backbone Core (DABC)
 ********************************************************************
 * Copyright (C) 2009- 
 * GSI Helmholtzzentrum fuer Schwerionenforschung GmbH 
 * Planckstr. 1
 * 64291 Darmstadt
 * Germany
 * Contact:  http://dabc.gsi.de
 ********************************************************************
 * This software can be used under the GPL license agreements as stated
 * in LICENSE.txt file which is part of the distribution.
 ********************************************************************/
#ifndef DABC_RootTreeOutput
#define DABC_RootTreeOutput

#ifndef DABC_DataIO
#include "dabc/DataIO.h"
#endif

/** This class intended to use tree TTree functionality from DABC
 *  But binary buffers is not really suited for tree-like store.
 *  Therefore class is dummy for the moment
 */

class TTree;

namespace dabc_root {

   class RootTreeOutput : public dabc::DataOutput {
      public:

         RootTreeOutput(const dabc::Url& url);
         virtual ~RootTreeOutput();

         virtual unsigned Write_Buffer(dabc::Buffer& buf);

      protected:

         TTree*       fTree;
   };

}

#endif
